package com.framsticks.communication.queries;

import com.framsticks.communication.Request;

import java.util.Collection;

/**
 * @author Piotr Sniegowski
 */
public abstract class ApplicationRequest extends Request {

    protected String path;
    protected String fields;

    public ApplicationRequest setPath(String path) {
        assert path != null;
        this.path = path;
        return this;
    }

    public ApplicationRequest setField(String field) {
        this.fields = field;
        return this;
    }

    public ApplicationRequest setFields(Collection<String> fields) {
        StringBuilder fieldString = new StringBuilder();
        boolean notFirst = false;
        for (String field : fields) {
            if (notFirst) {
                fieldString.append(",");

            } else {
                notFirst = true;
            }
            fieldString.append(field);
        }
        return setField(fieldString.toString());
    }


    public String getPath() {
        return path;
    }

    @Override
    protected StringBuilder construct(StringBuilder buffer) {
        buffer.append(' ').append(path);
        if (fields != null) {
            buffer.append(' ').append(fields);
        }
        return buffer;
    }

    @Override
    public void parseRest(String rest) {
        path = rest;
    }

}
