package com.framsticks.communication.queries;

import com.framsticks.communication.Request;

import java.util.List;

/**
 * @author Piotr Sniegowski
 */
public class CallRequest extends ApplicationRequest {
	protected String arguments;
	protected String method;


	public CallRequest setArguments(String arguments) {
		this.arguments = arguments;
		return this;
	}

	public CallRequest setArguments(List<String> arguments) {
		StringBuilder buffer = new StringBuilder();
		for (String a : arguments) {
			String arg = a.trim();
			buffer.append(" ");
			Request.quoteValue(buffer, arg);
		}
		return this.setArguments(buffer.toString());
	}

	public CallRequest setMethod(String method) {
		this.method = method;
		return this;
	}

	@Override
	protected StringBuilder construct(StringBuilder buffer) {
		super.construct(buffer);
		if (method != null) {
			buffer.append(" ").append(method);
		}
		if (arguments != null) {
			buffer.append(arguments);
		}
        return buffer;
	}

	@Override
	public String getCommand() {
		return "call";
	}

}
