package com.framsticks.communication.queries;

import com.framsticks.communication.Request;

/**
 * @author Piotr Sniegowski
 */
public class RegistrationRequest extends ApplicationRequest {
	boolean register = true;

	public RegistrationRequest() {
	}

	public RegistrationRequest register(boolean register) {
		this.register = register;
		return this;
	}

    @Override
	protected StringBuilder construct(StringBuilder buffer) {
        super.construct(buffer);
		if (!register) {
			buffer.append(" remove");
		}
        return buffer;
	}

	public String getCommand() {
		return register ? "reg" : "call";
	}

}
