package com.framsticks.communication.queries;

import com.framsticks.communication.Request;

/**
 * @author Piotr Sniegowski
 */
public class SetRequest extends ApplicationRequest {
	protected String value;

	public SetRequest() {
	}

	public SetRequest value(String value) {
		this.value = value;
		return this;
	}

	@Override
	protected StringBuilder construct(StringBuilder buffer) {
		super.construct(buffer);
		if (value != null) {
			buffer.append(" \"").append(value).append("\"");
		}
        return buffer;
	}
	@Override
	public String getCommand() {
		return "set";
	}
}
