package com.framsticks.communication.queries;

import com.framsticks.communication.Request;

/**
 * @author Piotr Sniegowski
 */
public class UseRequest extends ProtocolRequest {
	protected String feature;

	public UseRequest feature(String feature) {
		this.feature = feature;
		return this;
	}

    @Override
	public String getCommand() {
		return "use";
	}

    @Override
	protected StringBuilder construct(StringBuilder buffer) {
		return buffer.append(' ').append(feature);
	}

    @Override
    public void parseRest(String rest) {
        feature = rest;
    }

    public final String getFeature() {
        return feature;
    }
}
