package com.framsticks.communication.queries;

import com.framsticks.communication.Request;
import com.framsticks.util.Numbers;
import com.sun.j3d.loaders.ParsingErrorException;

/**
 * @author Piotr Sniegowski
 */
public class VersionRequest extends ProtocolRequest {
	protected Integer version;

	public VersionRequest() {
	}

	public VersionRequest version(Integer version) {
		this.version = version;
		return this;
	}

    @Override
	public String getCommand() {
		return "version";
	}

    @Override
    public void parseRest(String rest) {
        version = Numbers.parse(rest, Integer.class);
    }

    @Override
    protected StringBuilder construct(StringBuilder buffer) {
		return buffer.append(' ').append(version);
	}

}
