package com.framsticks.communication.util;

import com.framsticks.communication.StateCallback;
import org.apache.log4j.Logger;
import org.apache.log4j.Priority;

/**
 * @author Piotr Sniegowski
 */
public class LoggingStateCallback extends StateCallback {

	protected final Logger logger;
	protected final String message;

	public LoggingStateCallback(Logger logger, String message) {
		this.logger = logger;
		this.message = message;
	}

	@Override
	public void call(Exception e) {
		if (e != null) {
			logger.error("failed to " + message + " with " + e);
			return;
		}
        logger.debug(message);
	}
}
