package com.framsticks.core;

import com.framsticks.params.FramsClass;
import com.framsticks.params.ListSource;
import com.framsticks.params.ParamBuilder;
import com.framsticks.params.types.DecimalParam;
import com.framsticks.params.types.EnumParam;
import com.framsticks.params.types.StringParam;
import com.framsticks.util.Strings;

import java.util.ArrayList;
import java.util.Arrays;

/**
 * @author Piotr Sniegowski
 */
public class ListChange {

    public Action getAction() {
        return action;
    }

    public Integer getPosition() {
        return position;
    }

    public String getIdentifier() {
        return identifier;
    }

    public static enum Action {
        Add,
        Remove,
        Modify
    }

    private Action action;
    private Integer position;
    private String identifier;

    public Integer getType() { return action.ordinal(); }
    public void setType(Integer type) { action = Action.values()[type]; }

	public Integer getPos() { return position; }
	public void setPos(Integer pos) { position = pos; }

	public String getId() { return identifier; }
	public void setId(String id) { identifier = id; }

    public String getBestIdentifier() {
        if (Strings.notEmpty(identifier)) {
            return identifier;
        }
        return position.toString();
    }

    public static FramsClass getFramsClass() {

        ArrayList<String> actions = new ArrayList<String>();
        actions.add("Add");
        actions.add("Remove");
        actions.add("Modify");
        return new FramsClass("ListChange", "ListChange", null)
                .append(new ParamBuilder().setId("type").setName("type").setType(new EnumParam(actions)).build())
                .append(new ParamBuilder().setId("id").setName("identifier").setType(StringParam.class).build())
                .append(new ParamBuilder().setId("pos").setName("position").setType(DecimalParam.class).build());
    }

    @Override
    public String toString() {
        return action + " " + identifier + " " + position;
    }
}
