package com.framsticks.dumping;

import com.framsticks.params.SinkInterface;

import java.io.PrintStream;

/**
 * @author Piotr Sniegowski
 */
public class PrintStreamSink implements SinkInterface {

    protected final PrintStream stream;

    public PrintStreamSink(PrintStream stream) {
        this.stream = stream;
    }

    @Override
    public PrintStreamSink print(String str) {
        stream.print(str);
        return this;
    }

    @Override
    public PrintStreamSink print(Object obj) {
        stream.print(obj);
        return this;
    }

    @Override
    public void breakLine() {
        stream.print('\n');
    }

    @Override
    public void close() {
    }
}
