package com.framsticks.gui;

import java.util.HashMap;
import java.util.Map;

/**
 * @author Piotr Sniegowski
 */
public class EndpointAtFrame {
    protected final BrowserEndpoint endpoint;
    protected final Frame frame;
    protected final Map<String, Panel> knownPanels = new HashMap<String, Panel>();

    public EndpointAtFrame(BrowserEndpoint endpoint, Frame frame) {
        this.endpoint = endpoint;
        this.frame = frame;
    }


    public BrowserEndpoint getEndpoint() {
        return endpoint;
    }

    public Frame getFrame() {
        return frame;
    }

    public void registerPanel(Panel panel) {
        assert frame.isActive();
        knownPanels.put(panel.getClassName(), panel);
        frame.cardPanel.add(panel, panel.getFullName());
    }

    public Panel findPanel(String className) {
        assert frame.isActive();
        return (knownPanels.containsKey(className) ? knownPanels.get(className) : null);
    }

    public final String getName() {
        return endpoint.getName();
    }
}
