package com.framsticks.gui;

import com.framsticks.util.Dispatcher;
import com.framsticks.util.Task;

import javax.swing.*;
import java.awt.*;

/**
 * @author Piotr Sniegowski
 */
public class SwingDispatcher implements Dispatcher {

    public static final SwingDispatcher instance = new SwingDispatcher();

    public SwingDispatcher() {
        invokeLater(new Runnable() {
            @Override
            public void run() {
                Thread.currentThread().setName("gui");
            }
        });
    }

    @Override
    public final boolean isActive() {
        return SwingUtilities.isEventDispatchThread();
    }

    @Override
    public final void invokeLater(Runnable runnable) {
        assert !(runnable instanceof Task);
        SwingUtilities.invokeLater(runnable);
    }

}
