package com.framsticks.gui.components;

import com.framsticks.params.types.BooleanParam;
import org.apache.log4j.Logger;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

@SuppressWarnings("serial")
public class CheckBoxControl extends ValueControl {

	private static final Logger LOGGER = Logger.getLogger(CheckBoxControl.class.getName());

	private JCheckBox checkBox;

	public CheckBoxControl(BooleanParam booleanParam) {
		super(booleanParam);
		checkBox = new JCheckBox();
        checkBox.setEnabled(!isReadOnly());
		checkBox.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent actionEvent) {
				LOGGER.debug("change to: " + checkBox.isSelected());
				notifyOfChange();
			}
		});
		this.setMaximumSize(new Dimension(Integer.MAX_VALUE, Control.LINE_HEIGHT));
		addAsOnlyChild(checkBox);
	}

	@Override
	public void setValueImpl(Object value) {
		if (value == null) {
			return;
		}
		checkBox.setSelected((Boolean) value);
	}

	@Override
	public Object getValue() {
		return checkBox.isSelected();
	}

}
