package com.framsticks.gui.components;

import com.framsticks.gui.ObjectPanel;
import com.framsticks.params.Param;
import com.framsticks.params.types.ProcedureParam;
import org.apache.log4j.Logger;

import javax.swing.*;
import javax.swing.border.BevelBorder;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import java.util.Map;

@SuppressWarnings("serial")
public class ProcedureControl extends Control {
	private static final Logger LOGGER = Logger.getLogger(Control.class.getName());

	JButton procedureButton;

	final protected Map<Param, Control> components = new HashMap<Param, Control>();

	public ProcedureControl(ProcedureParam procedureParam) {
		super(procedureParam);

		procedureButton = new JButton("Call");

		this.setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));

		ObjectPanel.fillWithComponents(this, procedureParam.getArgumentsType(), components);

		if (components.size() != procedureParam.getArgumentsType().size()) {
			procedureButton.setEnabled(false);
		}
		if (!components.isEmpty()) {
			this.setBorder(new BevelBorder(BevelBorder.RAISED));
		}

		procedureButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {

/*
				Node node = panel.getCurrentNode();
				if (argumentWindow != null) {
					argumentWindow.askForArguments();
					return;
				}
				node.getConnection().send(new CallQuery().setMethod(param.getId()).setPath(node.getPath()).setCallback(new QueryCallback() {
					@Override
					public void call(boolean ok, String comment, SourceInterface content) {
						if (!ok) {
							LOGGER.error("failed to call method: " + param);
							return;
						}
						LOGGER.debug("successful call of method: " + param);
					}
				}));
*/
			}
		});
		this.add(procedureButton);

	}

}
