package com.framsticks.gui.components;

import com.framsticks.params.types.ValueParam;
import org.apache.log4j.Logger;

import javax.swing.*;
import java.awt.*;


@SuppressWarnings("serial")
public class TextAreaControl extends ValueControl {

	private static final Logger LOGGER = Logger.getLogger(TextAreaControl.class.getName());

	private JTextArea textArea;
	private JScrollPane textScrollPane;

	public TextAreaControl(ValueParam valueParam) {
		super(valueParam);
		textArea = new JTextArea();
		//textArea.setFont(FONT);
		textArea.setLineWrap(true);
		textArea.setWrapStyleWord(true);
        textArea.setEditable(!isReadOnly());
		textArea.getDocument().addDocumentListener(createDocumentListener(this));
		//textArea.setBackground(new Color(255, 0, 0));

		textScrollPane = new JScrollPane(textArea);
		//textScrollPane.setMaximumSize(new Dimension(Integer.MAX_VALUE, LINE_HEIGHT * 3));
		//textArea.setMaximumSize(new Dimension(Integer.MAX_VALUE, LINE_HEIGHT * 3));
		//this.setLayout(new BorderLayout());
		//this.add(textScrollPane, BorderLayout.CENTER);
		//this.add(Box.createRigidArea(new Dimension(5, 0)), BorderLayout.PAGE_START);
		//this.add(Box.createRigidArea(new Dimension(5, 0)), BorderLayout.PAGE_END);
		this.setLayout(new BorderLayout());
		this.add(textScrollPane, BorderLayout.CENTER);
		this.setMaximumSize(new Dimension(Integer.MAX_VALUE, LINE_HEIGHT * 3));
		textArea.setMaximumSize(new Dimension(Integer.MAX_VALUE, LINE_HEIGHT * 3));

		this.revalidate();
	}

	@Override
	public Dimension getPreferredSize() {
		Dimension result = super.getPreferredSize();
		return new Dimension(result.width, Math.min(result.height, this.getMaximumSize().height));
	}

	@Override
	public void setValueImpl(Object value) {
		textArea.setText((String) value);
		this.revalidate();
		//textArea.set
		//textArea.setRows(Math.min(textArea.getLineCount(), 5));
		//textArea.setColumns(50);
		//textArea.getDocument().
		//textArea.revalidate();
	}

	@Override
	public Object getValue() {
		return textArea.getText();
	}

}
