package com.framsticks.model;

import com.framsticks.model.MechPart;
import com.framsticks.model.Joint;
import com.framsticks.util.Point3d;

import java.util.ArrayList;
import java.util.List;

public class Creature {
	public String name;

	public String genotype;

	public String info;

	public Object group;

	public Integer generation;
	public Integer getGnum() { return generation; }
	public void setGnum(Integer gnum) { generation = gnum; }

	public Integer buildProblems;
	public Integer getBuildproblems() { return buildProblems; }
	public void setBuildproblems(Integer buildproblems) { buildProblems = buildproblems; }

	public Double startingEnergy;
	public Double getEnerg0() { return startingEnergy; }
	public void setEnerg0(Double energ0) { startingEnergy = energ0; }

	public Double idlePowerConsumption;
	public Double getIdleen() { return idlePowerConsumption; }
	public void setIdleen(Double idleen) { idlePowerConsumption = idleen; }

	public Double energy;

	public Double energyIncome;
	public Double getEnergy_p() { return energyIncome; }
	public void setEnergy_p(Double energy_p) { energyIncome = energy_p; }

	public Double energyCosts;
	public Double getEnergy_m() { return energyCosts; }
	public void setEnergy_m(Double energy_m) { energyCosts = energy_m; }

	public Double energyBalance;
	public Double getEnergy_b() { return energyBalance; }
	public void setEnergy_b(Double energy_b) { energyBalance = energy_b; }

	public Integer performanceCalculation;
	public Integer getPerf() { return performanceCalculation; }
	public void setPerf(Integer perf) { performanceCalculation = perf; }

	public Boolean neuralNetworkEnabled;

	public Boolean getNnenabled() { return neuralNetworkEnabled; }
	public void setNnenabled(Boolean nnenabled) { neuralNetworkEnabled = nnenabled; }

	public Boolean bodySimulation;
	public Boolean getBodysim() { return bodySimulation; }
	public void setBodysim(Boolean bodysim) { bodySimulation = bodysim; }

	public Boolean selfCollisions;
	public Boolean getSelfcol() { return selfCollisions; }
	public void setSelfcol(Boolean selfcol) { selfCollisions = selfcol; }

	public Integer lifeSpan;
	public Integer getLifespan() { return lifeSpan; }
	public void setLifespan(Integer lifespan) { lifeSpan = lifespan; }

	public Double distance;

	public Double currentVelocity;
	public Double getC_velocity() { return currentVelocity; }
	public void setC_velocity(Double c_velocity) { currentVelocity = c_velocity; }

	public Double currentVerticalVelocity;
	public Double getC_vertvelocity() { return currentVerticalVelocity; }
	public void setC_vertvelocity(Double c_vertvelocity) { currentVerticalVelocity = c_vertvelocity; }

	public Double currentVerticalPosition;
	public Double getC_vertpos() { return currentVerticalPosition; }
	public void setC_vertpos(Double c_vertpos) { currentVerticalPosition = c_vertpos; }

	public Double averageVelocity;
	public Double getVelocity() { return averageVelocity; }
	public void setVelocity(Double c_velocity) { averageVelocity = c_velocity; }

	public Double averageVerticalVelocity;
	public Double getVertvel() { return averageVerticalVelocity; }
	public void setVertvel(Double c_vertvelocity) { averageVerticalVelocity = c_vertvelocity; }

	public Double averageVerticalPosition;
	public Double getVertpos() { return averageVerticalPosition; }
	public void setVertpos(Double c_vertpos) { averageVerticalPosition = c_vertpos; }

	public Point3d position = new Point3d();

	public Double getPos_x() { return position.x; }
	public void setPos_x(Double pos_x) { position.x = pos_x; }

	public Double getPos_y() { return position.y; }
	public void setPos_y(Double pos_y) { position.y = pos_y; }

	public Double getPos_z() { return position.z; }
	public void setPos_z(Double pos_z) { position.z = pos_z; }

	public Point3d boundingBox = new Point3d();
	public Double getSize_x() { return boundingBox.x; }
	public void setSize_x(Double size_x) { boundingBox.x = size_x; }

	public Double getSize_y() { return boundingBox.y; }
	public void setSize_y(Double size_y) { boundingBox.y = size_y; }

	public Double getSize_z() { return boundingBox.z; }
	public void setSize_z(Double size_z) { boundingBox.z = size_z; }

	public Point3d center = new Point3d();

	public Double getCenter_x() { return center.x; }
	public void setCenter_x(Double center_x) { center.x = center_x; }

	public Double getCenter_y() { return center.y; }
	public void setCenter_y(Double center_y) { center.y = center_y; }

	public Double getCenter_z() { return center.z; }
	public void setCenter_z(Double center_z) { center.z = center_z; }

	public Integer getNumparts() { return parts.size(); }
	public void setNumparts(Integer numparts) { }

	public Integer getNumjoints() { return joints.size(); }
	public void setNumjoints(Integer numjoints) { }

	public Integer getNumneurons() { return neurons.size(); }
	public void setNumneurons(Integer numneurons) { }

	public Object[] userFields = new Object[3];
	public Object getUser1() { return userFields[0]; }
	public void setUser1(Object user1) { userFields[0] = user1; }

	public Object getUser2() { return userFields[1]; }
	public void setUser2(Object user2) { userFields[1] = user2; }

	public Object getUser3() { return userFields[2]; }
	public void setUser3(Object user3) { userFields[2] = user3; }

	public Integer selfCollisionMask;
	public Integer getSelfmask() { return selfCollisionMask; }
	public void setSelfmask(Integer selfmask) { selfCollisionMask = selfmask; }

	public Integer otherCollisionMask;
	public Integer getOthermask() { return otherCollisionMask; }
	public void setOthermask(Integer othermask) { otherCollisionMask = othermask; }

	public String uid;

	public Integer index;

	public final List<Part> parts = new ArrayList<Part>();
	public final List<Joint> joints = new ArrayList<Joint>();
	public final List<NeuroDef> neurodefs = new ArrayList<NeuroDef>();

	public final List<MechPart> mechparts = new ArrayList<MechPart>();
	public final List<MechJoint> mechjoints = new ArrayList<MechJoint>();
	public final List<Neuro> neurons = new ArrayList<Neuro>();



}
