package com.framsticks.model;


import com.framsticks.util.Containers;

import java.util.ArrayList;
import java.util.List;

public class Genotype {
	public String name;
	public String genotype;
	public String info;

	public Double similarity;
	public Double getSimi() { return similarity; }
	public void setSimi(Double simi) { similarity = simi; }

	public Double startingEnergy;
	public Double getEnerg0() { return startingEnergy; }
	public void setEnerg0(Double energ0) { startingEnergy = energ0; }

	public Double brainConnections;
	public Double getNumconnections() { return brainConnections; }
	public void setNumconnections(Double numconnections) { brainConnections = numconnections; }

    public Integer ordinalNumber;
	public Integer getNum() { return ordinalNumber; }
	public void setNum(Integer num) { ordinalNumber = num; }

    public Integer generation;
	public Integer getGnum() { return generation; }
	public void setGnum(Integer gnum) { generation = gnum; }

	public Integer instances;

	public Integer lifeSpan;
	public Integer getLifespan() { return lifeSpan; }
	public void setLifespan(Integer lifespan) { lifeSpan = lifespan; }

	public Double velocity;
	public Double distance;


	public Double verticalVelocity;
	public Double getVertvel() { return verticalVelocity; }
	public void setVertvel(Double vertvel) { verticalVelocity = vertvel; }

	public Double verticalPosition;
	public Double getVertpos() { return verticalPosition; }
	public void setVertpos(Double vertpos) { verticalPosition = vertpos; }

	public Double fitness;
	public Double getFit() { return fitness; }
	public void setFit(Double fit) { fitness = fit; }

	public Double finalFitness;
	public Double getFit2() { return finalFitness; }
	public void setFit2(Double fit2) { finalFitness = fit2; }

	public String genotypeInF0;
	public String getF0genotype() { return genotypeInF0; }
	public void setF0genotype(String f0genotype) { genotypeInF0 = f0genotype; }

	public String conversionBacktrace;
	public String getConvtrace1() { return conversionBacktrace; }
	public void setConvtrace1(String convtrace1) { conversionBacktrace = convtrace1; }

	public Object[] userFields = new Object[3];
	public Object getUser1() { return userFields[0]; }
	public void setUser1(Object user1) { userFields[0] = user1; }

	public Object getUser2() { return userFields[1]; }
	public void setUser2(Object user2) { userFields[1] = user2; }

	public Object getUser3() { return userFields[2]; }
	public void setUser3(Object user3) { userFields[2] = user3; }

	public String uid;

	public final List<Part> parts = new ArrayList<Part>();
	public final List<Joint> joints = new ArrayList<Joint>();
	public final List<NeuroDef> neurodefs = new ArrayList<NeuroDef>();


    public Double getNumparts() { return (double)parts.size(); }
	public Double getNumjoints() { return (double)joints.size(); }
	public Double getNumneurons() { return (double)neurodefs.size(); }

    //this is impossible to use, because numparts field is marked as readonly
    public void setNumparts(Double numparts) { Containers.resizeList(parts, (int)(double)numparts); }
    public void setNumjoints(Double numjoints) { Containers.resizeList(joints, (int)(double)numjoints); }
    public void setNumneurons(Double numneurons) { Containers.resizeList(neurodefs, (int)(double)numneurons); }
}
