package com.framsticks.params;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Piotr Sniegowski
 */
public class Group {
	String name;

	/**
	 * Group members.
	 */
	List<Param> params = new ArrayList<Param>();

	public Group(String name) {
		this.name = name;
	}

	/**
	 * Adds new group member.
	 *
	 * @param p the new group member
	 */
	void addProperty(Param p) {
		params.add(p);
	}

	/**
	 * Gets the property.
	 *
	 * @param i the i
	 * @return the property
	 */
	Param getProperty(int i) {
		if (i < 0 || i >= params.size())
			return null;
		return params.get(i);
	}

	/*
			 * (non-Javadoc)
			 *
			 * @see java.lang.Object#toString()
			 */
	@Override
	public String toString() {
		return name;
	}

}
