package com.framsticks.params.types;

import com.framsticks.params.CastFailure;
import com.framsticks.util.Numbers;

/**
 * @author Piotr Sniegowski
 */
public class BinaryParam extends ValueParam {
	@Override
	public Class getStorageType() {
		return Integer.class;
	}

    @Override
    public String getType() {
        return "db";
    }

    @Override
    public Object reassign(Object newValue, Object oldValue) throws CastFailure {
        if (newValue instanceof String) {
            Integer v = Numbers.parse((String) newValue, Integer.class);
            if (v != null) {
                return v;
            }
            throw new CastFailure();
        }
        return super.reassign(newValue, oldValue);
    }

}
