package com.framsticks.params.types;

import com.framsticks.params.CastFailure;
import com.framsticks.params.SinkInterface;

/**
 * @author Piotr Sniegowski
 */
public class BooleanParam extends DecimalParam {
    @Override
    public Class getStorageType() {
        return Boolean.class;
    }

    @Override
    public Object reassign(Object newValue, Object oldValue) throws CastFailure {
		if (newValue instanceof Boolean) {
			return newValue;
		}
        Object casted = super.reassign(newValue, oldValue);
        if (casted instanceof Integer) {
            Integer i = (Integer)casted;
            if (i == 0) return false;
            if (i == 1) return true;
            throw new CastFailure();
        }
        /*
        if (newValue instanceof String) {
            if (newValue.equals("true")) return true;
            if (newValue.equals("false")) return false;
            throw new CastFailure();
        }
        */
        throw new CastFailure();
    }

    @Override
    public String getType() {
        return "d 0 1";
    }

    @Override
    public void save(SinkInterface sink, Object value) {
        assert value instanceof Boolean;
        sink.print(((Boolean)value) ? "1" : "0");
    }
}
