package com.framsticks.params.types;

import com.framsticks.params.AccessInterface;
import com.framsticks.params.CastFailure;

/**
 * @author Piotr Sniegowski
 */
public class ObjectParam extends CompositeParam {

	public ObjectParam(String containedTypeName) {
		super(containedTypeName);
	}

    @Override
    public String computeAccessId() {
        return containedTypeName;
    }

    @Override
	public Class getStorageType() {
		return Object.class;
	}

	@Override
	public boolean isEmptyAvailable() {
		return true;
	}

	@Override
	public Object reassign(Object newValue, Object oldValue) throws CastFailure {
		return newValue;
	}

    @Override
    public AccessInterface prepareAccessInterface(AccessInterface access) {
        return access;
    }

    @Override
    public String getType() {
        return "o " + containedTypeName;
    }




}
