package com.framsticks.params.types;

import com.framsticks.params.CastFailure;
import com.framsticks.params.SinkInterface;

/**
 * @author Piotr Sniegowski
 */
public class StringParam extends ValueParam {
	@Override
	public Class getStorageType() {
		return String.class;
	}

	@Override
	public boolean isEmptyAvailable() {
		return true;
	}

    @Override
    public Object reassign(Object newValue, Object oldValue) throws CastFailure {
        if (newValue instanceof String) {
            return (String)newValue;
        }
        return super.reassign(newValue, oldValue);
    }

    @Override
    public String getType() {
        return "s";
    }

    private static final String SEPARATOR = System.getProperty("line.separator");

    @Override
    public void save(SinkInterface sink, Object value) {
        assert value instanceof String;
        String s = (String)value;
        sink.print((s.contains(SEPARATOR) ? (s = "~" + SEPARATOR + s + "~") : s));
    }
}
