package com.framsticks.util;

/**
 * @author Piotr Sniegowski
 */
public abstract class Dispatching {

    public static boolean isThreadSafe() {
        return true;
    }

    public static void invokeLaterOrNow(Dispatcher dispatcher, Runnable runnable) {
        if (dispatcher.isActive()) {
            runnable.run();
            return;
        }
        dispatcher.invokeLater(runnable);
    }

    public static void dispatchOk(Dispatcher dispatcher, final StateFunctor stateFunctor) {
        dispatcher.invokeLater(new Runnable() {
            @Override
            public void run() {
                stateFunctor.call(null);
            }
        });
    }

    public static boolean assertInvokeLater(Dispatcher dispatcher, Runnable runnable) {
        dispatcher.invokeLater(runnable);
        return true;
    }

    public static void invokeDispatch(Dispatcher dispatcher, final Dispatcher finalDispatcher, final Runnable runnable) {
        dispatcher.invokeLater(new Runnable() {
            @Override
            public void run() {
                finalDispatcher.invokeLater(runnable);
            }
        });
    }

}
