package com.framsticks.util;

/**
 * @author Piotr Sniegowski
 */
public abstract class PeriodicTask implements Runnable {

    protected final long period;
    protected Dispatcher dispatcher;

    public PeriodicTask(Dispatcher dispatcher, long period) {
        this.period = period;
        this.dispatcher = dispatcher;
        dispatcher.invokeLater(this);
    }


    public void again() {
        dispatcher.invokeLater(new Task(System.currentTimeMillis() + period) {
            @Override
            public void run() {
                PeriodicTask.this.run();
            }
        });
    }

}
