package com.framsticks.util;


import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

/**
 * @author Piotr Sniegowski
 */
public class UnaryListenersSet<T> {
	Set<UnaryFunctor<Boolean, T>> listeners = new HashSet<UnaryFunctor<Boolean, T>>();

	public void add(UnaryFunctor<Boolean, T> listener) {
		listeners.add(listener);
	}

	public void call(T argument) {
		Iterator<UnaryFunctor<Boolean, T>> iterator = listeners.iterator();
		while (iterator.hasNext()) {
			if (iterator.next().call(argument)) {
				iterator.remove();
			}
		}
	}

}
